/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.engine.script;

import org.objectweb.petals.component.framework.listener.AbstractJBIListener;
import org.objectweb.petals.component.framework.util.Exchange;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public class JBIListener extends AbstractJBIListener {

    private ScriptContext context;

    /**
     * Creates a new instance of {@link JBIListener}
     * 
     */
    public JBIListener() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.component.framework.listener.AbstractListener#init()
     */
    @Override
    protected void init() {
        this.context = ((ScriptEngine) getComponent()).getScriptContext();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.component.framework.listener.AbstractJBIListener#onJBIMessage(org.objectweb.petals.component.framework.util.Exchange)
     */
    @Override
    protected void onJBIMessage(Exchange exchange) {
        JBIScript script = this.context.getScriptInstance(getProvides().toString());
        if (script != null) {
            try {
                script.process(exchange);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

}
